com.dlsc.flexgantt.swing.layer.timeline

## Class DefaultCapacityObjectRenderer

- java.lang.Object
- - java.awt.Component
  - - java.awt.Container
    - - javax.swing.JComponent
      - - javax.swing.JPanel
        - - com.dlsc.flexgantt.swing.layer.timeline.DefaultCapacityObjectRenderer

- All Implemented Interfaces:
    ITimelineObjectRenderer, IRenderer, ImageObserver, MenuContainer, Serializable, Accessible

      public class DefaultCapacityObjectRenderer
      extends JPanel
      implements ITimelineObjectRenderer

  A timeline object renderer that knows how to draw timeline objects that represent a capacity.
  Since:
    1.0
  Version:
    $Revision: 1.5 $
  Author:
    Dirk Lemmermann
  See Also:
    `DefaultCapacityObject`, Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class javax.swing.JPanel

      `JPanel.AccessibleJPanel`

    - ### Nested classes/interfaces inherited from class javax.swing.JComponent

      `JComponent.AccessibleJComponent`

    - ### Nested classes/interfaces inherited from class java.awt.Container

      `Container.AccessibleAWTContainer`

    - ### Nested classes/interfaces inherited from class java.awt.Component

      `Component.AccessibleAWTComponent, Component.BaselineResizeBehavior, Component.BltBufferStrategy, Component.FlipBufferStrategy`

  - ### Field Summary

    - ### Fields inherited from class javax.swing.JComponent

      `listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

    - ### Fields inherited from class java.awt.Component

      `accessibleContext, BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

    - ### Fields inherited from interface java.awt.image.ImageObserver

      `ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DefaultCapacityObjectRenderer()` Constructs a new capacity object renderer.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `firePropertyChange(String propertyName, boolean oldValue, boolean newValue)` Overriden for performance reasons.
    `void` | `firePropertyChange(String propertyName, byte oldValue, byte newValue)` Overriden for performance reasons.
    `void` | `firePropertyChange(String propertyName, char oldValue, char newValue)` Overriden for performance reasons.
    `void` | `firePropertyChange(String propertyName, double oldValue, double newValue)` Overriden for performance reasons.
    `void` | `firePropertyChange(String propertyName, float oldValue, float newValue)` Overriden for performance reasons.
    `void` | `firePropertyChange(String propertyName, long oldValue, long newValue)` Overriden for performance reasons.
    `protected void` | `firePropertyChange(String propertyName, Object oldValue, Object newValue)` Overriden for performance reasons.
    `void` | `firePropertyChange(String propertyName, short oldValue, short newValue)` Overriden for performance reasons.
    `protected ICapacityObject` | `getCapacityObject()` Returns the currently rendered capacity object.
    `Color` | `getFillColor()` Returns the color that will be used for filling the background of the renderer component.
    `Color` | `getFocusColor()` Returns the color that will be used for filling the background of the renderer component when the capacity object has the focus.
    `Color` | `getHighlightFillColor()` Returns the color that will be used for filling the background of the renderer component when the capacity object is highlighted.
    `protected TimelineObjectLayer` | `getLayer()` Returns the timeline object layer on which the capacity object is located.
    `Color` | `getOverallocationFillColor()`
    `Color` | `getPastFillColor()` Returns the color that will be used for filling the background of the renderer component when the capacity object is located in the past.
    `protected int` | `getRow()` Returns the number of the row on which the capacity object is located.
    `Color` | `getSelectionFillColor()` Returns the color that will be used for filling the background of the renderer component when the capacity object is selected.
    `TimelineObjectPath` | `getTimelineObjectPath()` Returns the path to the currently rendered capacity object.
    `Component` | `getTimelineObjectRendererComponent(TimelineObjectLayer layer, TimelineObjectPath path, boolean selected, boolean hasFocus, boolean highlighted, int row)` Returns a component that will be used to renderer the given timeline object.
    `Insets` | `getTimelineObjectRendererInsets(int x, int y, int width, int height)` Returns the insets of the object renderer.
    `boolean` | `hasFocus()` Determines if the capacity object has the focus.
    `void` | `invalidate()` Overriden for performance reasons.
    `protected boolean` | `isHighlighted()` Determines whether the capacity object is currently highlighted or not.
    `protected boolean` | `isSelected()` Determines whether the capacity object is selected or not.
    `boolean` | `isVisible()` Overriden in order to fix a bug in AWT, which causes the cursor to flicker during drag and drop operations.
    `protected void` | `paintComponent(Graphics g)`
    `void` | `repaint()` Overriden for performance reasons.
    `void` | `repaint(int x, int y, int width, int height)` Overriden for performance reasons.
    `void` | `repaint(long tm)` Overriden for performance reasons.
    `void` | `revalidate()` Overriden for performance reasons.
    `void` | `setFillColor(Color color)` Sets the color that will be used for filling the background of the renderer component.
    `void` | `setFocusColor(Color color)` Sets the color that will be used for filling the background of the renderer component when the capacity object has the focus.
    `void` | `setHighlightFillColor(Color color)` Sets the color that will be used for filling the background of the renderer component when the capacity object is highlighted.
    `void` | `setOverallocationFillColor(Color overallocationFillColor)`
    `void` | `setPastFillColor(Color color)` Sets the color that will be used for filling the background of the renderer component when the capacity object is located in the past.
    `void` | `setSelectionFillColor(Color color)` Sets the color that will be used for filling the background of the renderer component when the capacity object is selected.
    `void` | `validate()` Overriden for performance reasons.

    - ### Methods inherited from class javax.swing.JPanel

      `getAccessibleContext, getUI, getUIClassID, paramString, setUI, updateUI`

    - ### Methods inherited from class javax.swing.JComponent

      `addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentGraphics, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, hide, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingOrigin, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintImmediately, paintImmediately, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, reshape, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

    - ### Methods inherited from class java.awt.Container

      `add, add, add, add, add, addContainerListener, addImpl, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusDownCycle, validateTree`

    - ### Methods inherited from class java.awt.Component

      `action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setName, setSize, setSize, show, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### DefaultCapacityObjectRenderer

          public DefaultCapacityObjectRenderer()

      Constructs a new capacity object renderer.
      Since:
        1.0

  - ### Method Detail

    - #### getTimelineObjectRendererComponent

          public Component getTimelineObjectRendererComponent(TimelineObjectLayer layer,
                                                              TimelineObjectPath path,
                                                              boolean selected,
                                                              boolean hasFocus,
                                                              boolean highlighted,
                                                              int row)

      Description copied from interface: `ITimelineObjectRenderer`
      Returns a component that will be used to renderer the given timeline object.
      Specified by:
        `getTimelineObjectRendererComponent` in interface `ITimelineObjectRenderer`
      Parameters:
        `layer` - the layer in which the timeline object will be rendered
        `path` - the path to the timeline object that gets rendered
        `selected` - if TRUE the object is currently selected and the rendering needs to express that
        `hasFocus` - if TRUE the focus is currently on the timeline object and the rendering needs to express that
        `highlighted` - if TRUE the timeline object is highlighted and its appearance needs to vary from its normal appearance (causing a blinking effect)
        `row` - the row in which the object gets drawn
      Returns:
        the component used for rendering the given object

    - #### getTimelineObjectRendererInsets

          public Insets getTimelineObjectRendererInsets(int x,
                                                        int y,
                                                        int width,
                                                        int height)

      Description copied from interface: `ITimelineObjectRenderer`
      Returns the insets of the object renderer. The insets are important if the renderer doesn't use the entire rectangle that it could use (for example a bar that doesn't use the entire height of the row, which is quite common, see also `DefaultActivityObjectRenderer`).
      Specified by:
        `getTimelineObjectRendererInsets` in interface `ITimelineObjectRenderer`
      Parameters:
        `x` - the x-coordinate of the bounds that will be assigned to the renderer component
        `y` - the y-coordinate of the bounds that will be assigned to the renderer component
        `width` - the width of the bounds that will be assigned to the renderer component
        `height` - the height of the bounds that will be assigned to the renderer component
      Returns:
        the renderers insets (unused space above, below, to the left, to the right)

    - #### paintComponent

          protected void paintComponent(Graphics g)

      Overrides:
        `paintComponent` in class `JComponent`

    - #### getFillColor

          public Color getFillColor()

      Returns the color that will be used for filling the background of the renderer component.
      Returns:
        the color used for the background of the renderer
      Since:
        1.0

    - #### setFillColor

          public void setFillColor(Color color)

      Sets the color that will be used for filling the background of the renderer component.
      Parameters:
        `color` - the color used for the background of the renderer
      Since:
        1.0

    - #### getFocusColor

          public Color getFocusColor()

      Returns the color that will be used for filling the background of the renderer component when the capacity object has the focus.
      Returns:
        the color used for the background of the renderer when the capacity object has the focus
      Since:
        1.0

    - #### setFocusColor

          public void setFocusColor(Color color)

      Sets the color that will be used for filling the background of the renderer component when the capacity object has the focus.
      Parameters:
        `color` - the color used for the background when the capacity object has the focus
      Since:
        1.0

    - #### getHighlightFillColor

          public Color getHighlightFillColor()

      Returns the color that will be used for filling the background of the renderer component when the capacity object is highlighted.
      Returns:
        the color used for the background of the renderer when the capacity object is highlighted
      Since:
        1.0

    - #### setHighlightFillColor

          public void setHighlightFillColor(Color color)

      Sets the color that will be used for filling the background of the renderer component when the capacity object is highlighted.
      Parameters:
        `color` - the color used for the background when the capacity object is highlighted
      Since:
        1.0

    - #### getPastFillColor

          public Color getPastFillColor()

      Returns the color that will be used for filling the background of the renderer component when the capacity object is located in the past.
      Returns:
        the color used for the background of the renderer when the capacity object is located in the past
      Since:
        1.0

    - #### setPastFillColor

          public void setPastFillColor(Color color)

      Sets the color that will be used for filling the background of the renderer component when the capacity object is located in the past.
      Parameters:
        `color` - the color used for the background when the capacity object is located in the past
      Since:
        1.0

    - #### getSelectionFillColor

          public Color getSelectionFillColor()

      Returns the color that will be used for filling the background of the renderer component when the capacity object is selected.
      Returns:
        the color used for the background of the renderer when the capacity object is selected
      Since:
        1.0

    - #### setSelectionFillColor

          public void setSelectionFillColor(Color color)

      Sets the color that will be used for filling the background of the renderer component when the capacity object is selected.
      Parameters:
        `color` - the color used for the background when the capacity object is selected
      Since:
        1.0

    - #### hasFocus

          public boolean hasFocus()

      Determines if the capacity object has the focus.
      Overrides:
        `hasFocus` in class `Component`
      Returns:
        TRUE if the capacity object has the focus
      Since:
        1.0

    - #### getCapacityObject

          protected ICapacityObject getCapacityObject()

      Returns the currently rendered capacity object.
      Returns:
        the rendered capacity object
      Since:
        1.0

    - #### isSelected

          protected boolean isSelected()

      Determines whether the capacity object is selected or not.
      Returns:
        TRUE if the capacity object is selected.
      Since:
        1.0

    - #### isHighlighted

          protected boolean isHighlighted()

      Determines whether the capacity object is currently highlighted or not.
      Returns:
        TRUE if the capacity object is highlighted
      Since:
        1.0
      See Also:
        `LayerContainer.addHighlightedObject(com.dlsc.flexgantt.model.gantt.TimelineObjectPath)`

    - #### getRow

          protected int getRow()

      Returns the number of the row on which the capacity object is located.
      Returns:
        the row number
      Since:
        1.0

    - #### getLayer

          protected TimelineObjectLayer getLayer()

      Returns the timeline object layer on which the capacity object is located.
      Returns:
        the timeline object layer where the capacity object gets rendered
      Since:
        1.0

    - #### validate

          public void validate()

      Overriden for performance reasons.
      Overrides:
        `validate` in class `Container`
      Since:
        1.0

    - #### invalidate

          public void invalidate()

      Overriden for performance reasons.
      Overrides:
        `invalidate` in class `Container`
      Since:
        1.0

    - #### revalidate

          public void revalidate()

      Overriden for performance reasons.
      Overrides:
        `revalidate` in class `JComponent`
      Since:
        1.0

    - #### firePropertyChange

          public void firePropertyChange(String propertyName,
                                         boolean oldValue,
                                         boolean newValue)

      Overriden for performance reasons.
      Overrides:
        `firePropertyChange` in class `JComponent`
      Since:
        1.0

    - #### firePropertyChange

          public void firePropertyChange(String propertyName,
                                         byte oldValue,
                                         byte newValue)

      Overriden for performance reasons.
      Overrides:
        `firePropertyChange` in class `Component`
      Since:
        1.0

    - #### firePropertyChange

          public void firePropertyChange(String propertyName,
                                         char oldValue,
                                         char newValue)

      Overriden for performance reasons.
      Overrides:
        `firePropertyChange` in class `JComponent`
      Since:
        1.0

    - #### firePropertyChange

          public void firePropertyChange(String propertyName,
                                         double oldValue,
                                         double newValue)

      Overriden for performance reasons.
      Overrides:
        `firePropertyChange` in class `Component`
      Since:
        1.0

    - #### firePropertyChange

          public void firePropertyChange(String propertyName,
                                         float oldValue,
                                         float newValue)

      Overriden for performance reasons.
      Overrides:
        `firePropertyChange` in class `Component`
      Since:
        1.0

    - #### firePropertyChange

          public void firePropertyChange(String propertyName,
                                         long oldValue,
                                         long newValue)

      Overriden for performance reasons.
      Overrides:
        `firePropertyChange` in class `Component`
      Since:
        1.0

    - #### firePropertyChange

          protected void firePropertyChange(String propertyName,
                                            Object oldValue,
                                            Object newValue)

      Overriden for performance reasons.
      Overrides:
        `firePropertyChange` in class `Component`
      Since:
        1.0

    - #### firePropertyChange

          public void firePropertyChange(String propertyName,
                                         short oldValue,
                                         short newValue)

      Overriden for performance reasons.
      Overrides:
        `firePropertyChange` in class `Component`
      Since:
        1.0

    - #### repaint

          public void repaint()

      Overriden for performance reasons.
      Overrides:
        `repaint` in class `Component`
      Since:
        1.0

    - #### repaint

          public void repaint(int x,
                              int y,
                              int width,
                              int height)

      Overriden for performance reasons.
      Overrides:
        `repaint` in class `Component`
      Since:
        1.0

    - #### repaint

          public void repaint(long tm)

      Overriden for performance reasons.
      Overrides:
        `repaint` in class `Component`
      Since:
        1.0

    - #### isVisible

          public boolean isVisible()

      Overriden in order to fix a bug in AWT, which causes the cursor to flicker during drag and drop operations.
      Overrides:
        `isVisible` in class `Component`
      Since:
        1.1

    - #### getOverallocationFillColor

          public Color getOverallocationFillColor()

      Returns:
        the overallocationFillColor
      Since:
        1.0

    - #### setOverallocationFillColor

          public void setOverallocationFillColor(Color overallocationFillColor)

      Parameters:
        `overallocationFillColor` - the overallocationFillColor to set
      Since:
        1.0

    - #### getTimelineObjectPath

          public TimelineObjectPath getTimelineObjectPath()

      Returns the path to the currently rendered capacity object.
      Returns:
        the path to the capacity object
      Since:
        1.1

Copyright © 2006–2020 Dirk Lemmermann Software & Consulting. All rights reserved.